package event

type CCEvent struct {
	// 交易哈希
	TxID string
	// 执行器名称,也可能是合约地址
	CCID string
	// 事件名称，go中表示actionName
	EventName string
	// 信息载体
	Payload []byte
	// 交易所在区块高度
	BlockNumber uint64
}

type (
	Registration interface{}
	EventService interface {
		// 注册区块监听
		// RegisterBlockEvent(filter ...BlockFilter) (chan <-Registration, <-chan *BlockEvent, error)

		// 注册交易时间监听
		RegisterTxEvent(ccID, eventFilter string) (chan<- Registration, <-chan *CCEvent, error)
	}
)
